package mosaic.sim.contBlocks;

import mosaic.sim.kernel.variable.*;
import mosaic.sim.kernel.continuous.*;
import mosaic.sim.kernel.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.ArrayList;
import javax.swing.JLabel;


/** Implements the Sumolute value. */
public class Sum extends AbstractContEquation{
   ArrayList addends=new ArrayList(10);
   ArrayList localFactors=new ArrayList(10);
   DoubleVariable[] tenAddends=new DoubleVariable[10];
   double[] tenLocalFactors={1,1,1,1,1,1,1,1,1,1};
   DoubleVariable output;
   JLabel la;
   public Sum() {
      super();
      initPaint();
      } // Sum;

   public Sum(String name) {
      super(name);
      initPaint();
      } // Sum


/*   public Sum(DoubleVariable input,DoubleVariable output){
      super();
      initPaint();
      setInput(input);
      setOutput(output);
      } // Sum;

   public Sum(String name,DoubleVariable input,DoubleVariable output){
      super(name);
      initPaint();
      setInput(input);
      setOutput(output);
      } // Sum

*/

  protected void initPaint(){
    la=new JLabel();
    la.setFont(new java.awt.Font("Dialog", 1, 10));
    la.setForeground(Color.black);
    la.setOpaque(false);
  }

  public void addAddend(DoubleVariable addend){
    addAddend(addend,1);
  }

  /** Set the input variable. */
  public void addAddend(DoubleVariable addend,double localFactor){
    if (addend==null) return;
    if (addends.contains(addend)) return;
    addends.add(addend);
    localFactors.add(new Double(localFactor));
    DoubleVariable domain[]=new DoubleVariable[addends.size()];
    for (int i=0;i<addends.size();i++) domain[i]=(DoubleVariable)addends.get(i);
    try{
      setDomains(domain);
    } catch(VariableException e){printErrorOutput(e.getMessage());}
  }

  /** Set the output variable. */
  public void setOutput(DoubleVariable output){
    this.output=output;
    try{
      setTargets(new DoubleVariable[]{output});
    } catch(VariableException e){printErrorOutput(e.getMessage());}
  }

  /** Returns the input variable. */
  public ArrayList getAddends(){
    return addends;
  }

  public double getLocalFactor(DoubleVariable addend){
    if (addend==null) return Double.NaN;
    int pos=addends.indexOf(addend);
    if (pos<0) return Double.NaN;
    Double f=(Double)localFactors.get(pos);
    return f.doubleValue();
  }

  public void setLocalFactor(DoubleVariable addend,double localFactor){
    if (addend==null) return;
    int pos=addends.indexOf(addend);
    if (pos<0) return;
    localFactors.set(pos,new Double(localFactor));
    changeOneOfTenLoc(addend,localFactor);
  }

  public void removeAddend(DoubleVariable addend){
    if (addend==null) return;
    int pos=addends.indexOf(addend);
    if (pos<0) return;
    addends.remove(pos);
    localFactors.remove(pos);
    remOneOfTen(addend);
  }

  protected void remOneOfTen(DoubleVariable addend){
    for (int i=0;i<10;i++){
      if (tenAddends[i]==addend) tenAddends[i]=null;
    }
  }

  protected void changeOneOfTenLoc(DoubleVariable addend,double localFactor){
    for (int i=0;i<10;i++){
      if (tenAddends[i]==addend) tenLocalFactors[i]=localFactor;
    }
  }

/*-- new addend  -----*/
  public void setAddend01(DoubleVariable addend){
    removeAddend(tenAddends[0]);
    tenAddends[0]=addend;
    addAddend(addend,tenLocalFactors[0]);
  }

  public DoubleVariable getAddend01(){
    return tenAddends[0];
  }

  public void setAddend01Factor(double localFactor){
    tenLocalFactors[0]=localFactor;
    setLocalFactor(tenAddends[0],localFactor);
  }

  public double getAddend01Factor(){
    return tenLocalFactors[0];
  }

/*-- new addend  -----*/
  public void setAddend02(DoubleVariable addend){
    removeAddend(tenAddends[1]);
    tenAddends[1]=addend;
    addAddend(addend,tenLocalFactors[1]);
  }

  public DoubleVariable getAddend02(){
    return tenAddends[1];
  }

  public void setAddend02Factor(double localFactor){
    tenLocalFactors[1]=localFactor;
    setLocalFactor(tenAddends[1],localFactor);
  }

  public double getAddend02Factor(){
    return tenLocalFactors[1];
  }

/*-- new addend  -----*/
  public void setAddend03(DoubleVariable addend){
    removeAddend(tenAddends[2]);
    tenAddends[2]=addend;
    addAddend(addend,tenLocalFactors[2]);
  }

  public DoubleVariable getAddend03(){
    return tenAddends[2];
  }

  public void setAddend03Factor(double localFactor){
    tenLocalFactors[2]=localFactor;
    setLocalFactor(tenAddends[2],localFactor);
  }

  public double getAddend03Factor(){
    return tenLocalFactors[2];
  }

/*-- new addend  -----*/
  public void setAddend04(DoubleVariable addend){
    removeAddend(tenAddends[3]);
    tenAddends[3]=addend;
    addAddend(addend,tenLocalFactors[3]);
  }

  public DoubleVariable getAddend04(){
    return tenAddends[3];
  }

  public void setAddend04Factor(double localFactor){
    tenLocalFactors[3]=localFactor;
    setLocalFactor(tenAddends[3],localFactor);
  }

  public double getAddend04Factor(){
    return tenLocalFactors[3];
  }

/*-- new addend  -----*/
  public void setAddend05(DoubleVariable addend){
    removeAddend(tenAddends[4]);
    tenAddends[4]=addend;
    addAddend(addend,tenLocalFactors[4]);
  }

  public DoubleVariable getAddend05(){
    return tenAddends[4];
  }

  public void setAddend05Factor(double localFactor){
    tenLocalFactors[4]=localFactor;
    setLocalFactor(tenAddends[4],localFactor);
  }

  public double getAddend05Factor(){
    return tenLocalFactors[4];
  }

/*-- new addend  -----*/
  public void setAddend06(DoubleVariable addend){
    removeAddend(tenAddends[5]);
    tenAddends[5]=addend;
    addAddend(addend,tenLocalFactors[5]);
  }

  public DoubleVariable getAddend06(){
    return tenAddends[5];
  }

  public void setAddend06Factor(double localFactor){
    tenLocalFactors[5]=localFactor;
    setLocalFactor(tenAddends[5],localFactor);
  }

  public double getAddend06Factor(){
    return tenLocalFactors[5];
  }

/*-- new addend  -----*/
  public void setAddend07(DoubleVariable addend){
    removeAddend(tenAddends[6]);
    tenAddends[6]=addend;
    addAddend(addend,tenLocalFactors[6]);
  }

  public DoubleVariable getAddend07(){
    return tenAddends[6];
  }

  public void setAddend07Factor(double localFactor){
    tenLocalFactors[6]=localFactor;
    setLocalFactor(tenAddends[6],localFactor);
  }

  public double getAddend07Factor(){
    return tenLocalFactors[6];
  }

/*-- new addend  -----*/
  public void setAddend08(DoubleVariable addend){
    removeAddend(tenAddends[7]);
    tenAddends[7]=addend;
    addAddend(addend,tenLocalFactors[7]);
  }

  public DoubleVariable getAddend08(){
    return tenAddends[7];
  }

  public void setAddend08Factor(double localFactor){
    tenLocalFactors[7]=localFactor;
    setLocalFactor(tenAddends[7],localFactor);
  }

  public double getAddend08Factor(){
    return tenLocalFactors[7];
  }

/*-- new addend  -----*/
  public void setAddend09(DoubleVariable addend){
    removeAddend(tenAddends[8]);
    tenAddends[8]=addend;
    addAddend(addend,tenLocalFactors[8]);
  }

  public DoubleVariable getAddend09(){
    return tenAddends[8];
  }

  public void setAddend09Factor(double localFactor){
    tenLocalFactors[8]=localFactor;
    setLocalFactor(tenAddends[8],localFactor);
  }

  public double getAddend09Factor(){
    return tenLocalFactors[8];
  }

/*-- new addend  -----*/
  public void setAddend10(DoubleVariable addend){
    removeAddend(tenAddends[9]);
    tenAddends[9]=addend;
    addAddend(addend,tenLocalFactors[9]);
  }

  public DoubleVariable getAddend10(){
    return tenAddends[9];
  }

  public void setAddend10Factor(double localFactor){
    tenLocalFactors[9]=localFactor;
    setLocalFactor(tenAddends[9],localFactor);
  }

  public double getAddend10Factor(){
    return tenLocalFactors[9];
  }


  /** Returns the output variable. */
  public DoubleVariable getOutput(){
    return output;
  }

  public void equation(){
    double sum=0;
    double localFactor;
    DoubleVariable addend;
    for (int i=0;i<addends.size();i++){
      addend=(DoubleVariable)addends.get(i);
      localFactor=((Double)localFactors.get(i)).doubleValue();
      sum=sum+addend.getValue()*localFactor;
    }
    output.setValue(sum);
  }

  public void paintComponent(Graphics g) {
    Graphics2D g2=(Graphics2D) g;
    int h = getSize().height-1;
    int w = getSize().width-1;
    int minWH=Math.min(h,w/2);
    int dist=Math.max(h/10,2);

    Color lineC;
    Color fillC;
/*    if (enabled) g.setColor(Color.black);
    else g.setColor(Color.gray);*/
    if (enabled){
      lineC=Color.black;
      fillC=Color.yellow;
    }
    else{
      lineC=Color.gray;
      fillC=Color.lightGray;
    }
    g2.setPaint(fillC);

//    Rectangle r=new Rectangle(w/4,0,w/2,h);
    Ellipse2D e=new Ellipse2D.Double(w/2-minWH/2,h/2-minWH/2,minWH,minWH);
    g2.fill(e);


    g2.setPaint(lineC);

    GeneralPath p=new GeneralPath(GeneralPath.WIND_EVEN_ODD);

    g2.draw(e);

    p.moveTo(0,h/2+dist);
    p.lineTo(0,h/2-dist);
    p.lineTo(w/2-minWH/2-dist*2,h/2-dist);
    p.lineTo(w/2-minWH/2-dist*2,h/2-dist*2);
    p.lineTo(w/2-minWH/2,h/2);
    p.lineTo(w/2-minWH/2-dist*2,h/2+dist*2);
    p.lineTo(w/2-minWH/2-dist*2,h/2+dist);
    p.closePath();
    g2.draw(p);

//    g2.draw(new Line2D.Double(0,h/2+dist,w/2-minWH/2,h/2+dist));
//    g2.draw(new Line2D.Double(0,h/2-dist,w/2-minWH/2,h/2-dist));

//    g2.draw(new Line2D.Double(0,h/2,w/2-minWH/2,h/2));
    g2.draw(new Line2D.Double(w/2+minWH/2,h/2,w,h/2));

//    la.setBounds((x1+x2)/2+5,(y1+y2)/2-10,(int)la.getPreferredSize().getWidth(),(int)la.getPreferredSize().getHeight());
    la.setHorizontalAlignment(la.CENTER);
    la.setVerticalAlignment(la.CENTER);

    la.setBounds(e.getBounds());
    Graphics2D g3=(Graphics2D)g2.create(w/2-minWH/2,h/2-minWH/2,minWH,minWH);
    la.setText("SUM");
    la.paint(g3);

    String input="";
    for (int i=0;i<addends.size();i++){
      input=input+((DoubleVariable)addends.get(i)).getLabel();
      if (i!=(addends.size()-1)) input=input+"+"; 
    }

    if (addends.size()>0){
      la.setBounds(0,0,w/2-minWH/2,h/2-dist);
      la.setText(input);
      la.setFont(new java.awt.Font("Dialog", 0, 10));
      la.setVerticalAlignment(la.BOTTOM);
      la.setHorizontalAlignment(la.LEFT);
      g3=(Graphics2D)g2.create(0,0,w/2-minWH/2,h/2-dist);
      la.paint(g3);
    }

    if (output!=null){
      la.setBounds(w/2+minWH/2,0,w/2-minWH/2,h/2);
      la.setText(output.getLabel());
      la.setHorizontalAlignment(la.RIGHT);
      g3=(Graphics2D)g2.create(w/2+minWH/2,0,w/2-minWH/2,h/2);
//      if (input==null){
        la.setFont(new java.awt.Font("Dialog", 0, 10));
        la.setVerticalAlignment(la.BOTTOM);
//      }
      la.paint(g3);
    }

  }

  public Dimension getPreferredSize() {
    return new Dimension(58,24);
  }


}