/**
 * Project mosaic
 *
 * ModelComponentEventListener.java
 *
 * copyright 2000, JKU Linz, Austria
 */

package mosaic.sim.kernel;

/**
 *  Interface specification for listeners of model component events. 
 */
public interface ModelComponentEventListener {

    /**
     * Reacts to an addition event
     * @param e the event object
     */
    public void modelComponentAdded (ModelComponentEvent e);
  
    /**
     * Reacts to a removal event
     * @param e the event object
     */
    public void modelComponentRemoved (ModelComponentEvent e);

    /**
     * Reacts to an enabled event
     * @param e the event object
     */
    public void modelComponentEnabled (ModelComponentEvent e);

    /**
     * Reacts to a disabled event
     * @param e the event object
     */
    public void modelComponentDisabled (ModelComponentEvent e);

    /**
     * Reacts to an  event when the model component got continuous (for DoubleVariable only)disabled event
     * @param e the event object
     */
    public void modelComponentGotContinuous (ModelComponentEvent e);

    /**
     * Reacts to an  event when the model component got discrete (for DoubleVariable only)disabled event
     * @param e the event object
     */
    public void modelComponentGotDiscrete (ModelComponentEvent e);

    /**
     * Reacts to an  event when the model component changed
     * @param e the event object
     */
    public void modelComponentChanged (ModelComponentEvent e);

}  // end ModelComponentEventListener ==============================================================






