/**
 * Project mosaic
 *
 * ModelComponentVisitor.java
 *
 * copyright 2000, JKU Linz, Austria
 */

package mosaic.sim.kernel;

/**
* Interface ModelComponentVisitor to implement visitors which visit all simulation components in
* the hierarchy.
* Use this as a base class for all visitors to perform operations on the hierarchy
* of ModelComponents.
*/
public interface ModelComponentVisitor {

    /**
    * Visit the ModelComponent and all subcomponents in the hierarchy.
    * @param c the ModelComponent visited.
    */
    public void visit(ModelComponent c);
}


