/**
 * Project mosaic
 *
 * ResetModelComponentVisitor.java
 *
 * copyright 2000, JKU Linz, Austria
 */


package mosaic.sim.kernel;

import java.util.*;

/**
* Implementation for ModelComponentVisitor which does an reset operation on all the components.
*/

public class ResetModelComponentVisitor extends AbstractModelComponentVisitor {

  public ResetModelComponentVisitor() {
  }

  public ResetModelComponentVisitor(ModelComponent root) {
    super(root);
  }

  /** Do a reset operation on the ModelComponent c */
  public void performOperation (ModelComponent c) {
    c.reset(); 
  }
}
