/**
 * Project mosaic
 *
 * SimpleMainFrame.java
 *
 * copyright 2000, JKU Linz, Austria
 */

package mosaic.sim.kernel;

import javax.swing.*;
import java.awt.*;

//==================================================================================================

/**
* Class for a simple simulation frame window with one model panel.
*/
public class SimpleMainFrame extends SimMainFrame  {

    /** Constructor which calls the constructor in the super class. */
    public SimpleMainFrame(SimApplication application) {
        super(application);
        try  {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace(getSimApplication().getLogPrinter().getLogStream("error"));
        }
   }

    private void jbInit() throws Exception {
    }


// model panel -------------------------------------------------------------------------------------

    /** Sets the model panel of this frame. This is the only panel in the frame. */
    public void setModelPanel(ModelPanel panel) {
        modelPanel = panel;
        simulationScrollPane = new JScrollPane(modelPanel);
        this.getContentPane().add(simulationScrollPane, BorderLayout.CENTER);
        addModelPanel(modelPanel);
    }

    /** Sets the model panel of this frame. This is the only panel in the frame. */
    ModelPanel modelPanel;

    /** ScrollPane to hold the model panel */
    JScrollPane simulationScrollPane;

}  // end SimpleMainFrame ==========================================================================
