package mosaic.sim.kernel.continuous;

/**
* Diese Ausnahmebedingung zeigt an, da fr ein Modell kein Integrator, der die
* mathematische Methode der Integration und deren Verwaltung der Daten kapselt,
* definiert wurde. Es mu die Memberfunktion <code>setIntegrator</code> der
* implementierten Interfaces <code>ContinuousModelContainer</code> oder
* <code>ContinuousModel</code> mit einer Instanz der Klasse <code>Integrator</code>
* aufgerufen werden.
*/

public class CSENoIntegrator
   extends ContSimulationException
   {
   /**
   * Erzeugt eine Instanz dieser Klasse mit fixem Fehlertext.
   */
   public CSENoIntegrator()
      { this("no integrator defined"); }

   /**
   * Erzeugt eine Instanz der Klasse mit bergebenem Fehlertext.
   * @param s Fehlertext der Ausnahmebedingung
   */
   public CSENoIntegrator(String s) 
      { super(s); }
   } // class CSENoIntegrator
   
// end of CSENoIntegrator.java   
