
package mosaic.sim.kernel.continuous;

import java.util.*;
import mosaic.sim.kernel.variable.*;
import mosaic.sim.kernel.*;

/**
* Class implementing a guard for a DoubleVariable variable crossing a value.
* <p>
* Implements the interface StateEventComponent.
* <b>Events:</b><p>
* <dl>
* <dt><code>zeroCrossingEvent</code></dt>
* <dd></dd>
* </dl>
*/

public abstract class VariableGuard
   extends  StateEventGuard
   {

   public VariableGuard()
   {  super ();
      real = null;
    }

   public VariableGuard(DoubleVariable real)
      { super();
        setDoubleVariable(real);
      }

   public VariableGuard(ModelComponent owner, String iLabel, DoubleVariable real)
      { super(owner, iLabel);
        setDoubleVariable(real);
      }

// variable ----------------------------------------------------------------------------------------

   /** guarded variable */
   protected DoubleVariable real;

   /**
   * Gets the guarded real variable
   */
   public DoubleVariable getDoubleVariable()
      { return real; }

   /**
   * Sets the guarded real variable
   */
   public void setDoubleVariable(DoubleVariable real)
      { this.real = real; }

  /** Gives a textual description of the value of the variable as debug information. */
  protected String getDebugText() {
    if (real != null)
      return ("of Variable " + real.getInfo());
    else
      return ("no Variable set");
  }


}


