
//Title:        Ihr Produktname
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       H. Praehofer
//Company:      Johannes Kepler University Linz
//Description:  Ihre Beschreibung

package mosaic.sim.kernel.input;

import java.beans.*;

public class BoundNumberInputViewBeanInfo extends SimpleBeanInfo {
  Class beanClass = BoundNumberInputView.class;
  String iconColor16x16Filename;
  String iconColor32x32Filename = "BoundNumberInputViewC32.gif";
  String iconMono16x16Filename;
  String iconMono32x32Filename;

  public BoundNumberInputViewBeanInfo() {
  }

  public PropertyDescriptor[] getPropertyDescriptors() {
    try  {
      PropertyDescriptor _maxVal = new PropertyDescriptor("maxVal", beanClass, "getMaxVal", "setMaxVal");
      PropertyDescriptor _minVal = new PropertyDescriptor("minVal", beanClass, "getMinVal", "setMinVal");
      PropertyDescriptor _number = new PropertyDescriptor("number", beanClass, "getNumber", "setNumber");
      PropertyDescriptor _value = new PropertyDescriptor("value", beanClass, null, "setValue");
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
	      _maxVal,
	      _minVal,
	      _number,
	      _value,};
      return pds;




    }
    catch(IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }

  public java.awt.Image getIcon(int iconKind) {
    switch (iconKind) {
	    case BeanInfo.ICON_COLOR_16x16:
	      return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
	    case BeanInfo.ICON_COLOR_32x32:
	      return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
	    case BeanInfo.ICON_MONO_16x16:
	      return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
	    case BeanInfo.ICON_MONO_32x32:
	      return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
	  }
    return null;
  }

  public BeanInfo[] getAdditionalBeanInfo() {
    Class superclass = beanClass.getSuperclass();
    try  {
      BeanInfo superBeanInfo = Introspector.getBeanInfo(superclass);
      return new BeanInfo[] { superBeanInfo };
    }
    catch(IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }
}
 
