
//Project:      SimBeans kernel
//Version:      0.3
//Copyright:    Copyright (c) 1998
//Author:       Herbert Praehofer, Johannes Sametinger, Alois Stritzinger
//Affiliation:  Johannes Kepler University, Linz, Austria

// -----------------------------------------------------------------------------------------------------------
// class ArrayListView     ----------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------
package mosaic.sim.kernel.output;

import java.awt.*;
import java.util.*;
import java.beans.*;

/**
* Base class for animation view to visualize a ArrayListVariable values.
* <p>
* @see sim.kernel.output.ArrayListTextView
* @see sim.kernel.output.ComponentArrayListPaintView
*
* @author Herbert Praehofer
* @author Johannes Sametinger
* @author Alois Stritzinger
* @version %I% %G% 
*/
public class CollectionView extends VariableView {

  /** Default constructor ArrayListView */
  public CollectionView() {
  }


// setValue --------------------------------------------------------------------------------------------------

  /**
  * Reacts to a new variable value by setting the ArrayList value.
  * Sets the text by calling <code>toString</code> of the vector.
  * @param newVal The new vector object received from the property change
  */
  public void setValue (Object newVal) {
      if ((newVal instanceof ArrayList) || (newVal == null)) {
            super.setValue(newVal);
      }
      else
            System.out.println(">> tried to send non ArrayList value to " + toString());
  }

  /** Gets the received object as a <code>ArrayList</code> object. */
  protected ArrayList retrieveItemArrayList() {
      if (value == null)
          return null;
      else
          return (ArrayList)value;
  }

  /**
  * Paints the <code>ArrayList</code> of <code>Item</code> objects.
  * Empty in this base class.
  * @param g the graphics context of the view
  */
  public void paintValue(Graphics g) {
  }
  
}

