
//Title:        Ihr Produktname
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       H. Praehofer
//Company:      Johannes Kepler University Linz
//Description:  Ihre Beschreibung

package mosaic.sim.kernel.output;

import java.beans.*;

public class FormattedNumberViewBeanInfo extends SimpleBeanInfo {
    Class beanClass = FormattedNumberView.class;
  String iconColor16x16Filename = "FormattedNumberViewC16.gif";
  String iconColor32x32Filename = "FormattedNumberViewC32.gif";
  String iconMono16x16Filename = "FormattedNumberViewC16.gif";
  String iconMono32x32Filename = "FormattedNumberViewC32.gif";

    public FormattedNumberViewBeanInfo() {
    }

    public PropertyDescriptor[] getPropertyDescriptors() {
        try  {
            PropertyDescriptor _digits = new PropertyDescriptor("digits", beanClass, "getDigits", "setDigits");
            PropertyDescriptor _unitString = new PropertyDescriptor("unitString", beanClass, "getUnitString", "setUnitString");
            PropertyDescriptor[] pds = new PropertyDescriptor[] {
	            _digits,
	            _unitString,};
            return pds;


        }
        catch(IntrospectionException ex) {
            ex.printStackTrace();
            return null;
        }
    }

    public java.awt.Image getIcon(int iconKind) {
        switch (iconKind) {
	        case BeanInfo.ICON_COLOR_16x16:
	          return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
	        case BeanInfo.ICON_COLOR_32x32:
	          return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
	        case BeanInfo.ICON_MONO_16x16:
	          return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
	        case BeanInfo.ICON_MONO_32x32:
	          return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
	    }
        return null;
    }

    public BeanInfo[] getAdditionalBeanInfo() {
        Class superclass = beanClass.getSuperclass();
        try  {
            BeanInfo superBeanInfo = Introspector.getBeanInfo(superclass);
            return new BeanInfo[] { superBeanInfo };
        }
        catch(IntrospectionException ex) {
            ex.printStackTrace();
            return null;
        }
    }
}
 
