
//Project:      SimBeans util
//Version:      0.3
//Copyright:    Copyright (c) 1998
//Author:       Herbert Praehofer, Johannes Sametinger, Alois Stritzinger
//Affiliation:  Johannes Kepler University, Linz, Austria

// -----------------------------------------------------------------------------------------------------------
// class   BasicUtilComponent               ------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------
// programmed by: hp
// last modified by: hp, 15.12.98
// documented by: hp, 15.12.98

package mosaic.sim.kernel.random;

import mosaic.sim.kernel.control.*;
import mosaic.sim.kernel.*;
import java.awt.*;

/** Base class for utility components, like random distributions and TimeSeeds.
*   Extends AbstractprintErrorOutput.
*   Defines special paint function.
*/

public class BasicRandomComponent extends AbstractModelComponent {

// Constructors ----------------------------------------------------------------------------------------------

  public BasicRandomComponent() {
      super ();
  }

  public BasicRandomComponent(String label) {
      setLabel (label);
  }

  /* Paints the BasicUtilComponent */
  public void paintComponent(Graphics g) {
        int h = getSize().height;
        int w = getSize().width;
        g.setColor(getBackground());
        g.setColor(getForeground());
        g.drawRect(0, 0, w-1, h-1);
        g.setFont(getFont());
        FontMetrics fm = g.getFontMetrics();
        g.setColor(getForeground());
        String l = getLabel();
        g.drawString(l,3,h-fm.getMaxDescent()-3);
  }


}
