
//Project:      SimBeans kernel
//Version:      0.3
//Copyright:    Copyright (c) 1998
//Author:       Herbert Praehofer, Johannes Sametinger, Alois Stritzinger
//Affiliation:  Johannes Kepler University, Linz, Austria

// -----------------------------------------------------------------------------------------------------------
// interface TimeSeed           --------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------
// programmed by: hp
// last modified by: hp, 29.12.98
// documented by: hp, 29.12.98


package mosaic.sim.kernel.random;

import mosaic.sim.kernel.*; 

/** Interface for objects to get time intervals for timing.
* Implemented by  objects to function as a time seed for time advances,
* like constant timing, random distributions, and time sequences.
*/

public interface TimeSeed extends ModelComponent
{
    /** Gets next time span (to the next event */
    public double getTimeSpan();
}