
//Project:        mosaic kernel
//Version:      0.3
//Copyright:    Copyright (c) 1998
//Author:       Herbert Praehofer, Johannes Sametinger, Alois Stritzinger
//Affiliation:  Johannes Kepler University, Linz, Austria

// -----------------------------------------------------------------------------------------------------------
// interface TimeEventListener -------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------
// programmed by: hp
// last modified by: hp, 14.12.98
// documented by: hp, 14.12.98


package mosaic.sim.kernel.simevent;

import java.util.EventListener;

/**
* Interface for listeners to TimeEvents.
* Extends SimEventListener. 
*/
public interface TimeEventListener extends mosaic.sim.kernel.simevent.SimEventListener {

  /** Adds a TimeEventComponent. Is called from addTimeEventListener of TimeEventComponent. */
  public void addTimeEventComponent (mosaic.sim.kernel.simevent.SimEventComponent c);

  /** Removes a TimeEventComponent. Is called from removeTimeEventListener of TimeEventComponent.  */
  public void removeTimeEventComponent (mosaic.sim.kernel.simevent.SimEventComponent c);

}
