
//Project:      SimBeans kernel
//Version:      0.3
//Copyright:    Copyright (c) 1998
//Author:       Herbert Praehofer, Johannes Sametinger, Alois Stritzinger
//Affiliation:  Johannes Kepler University, Linz, Austria

// -----------------------------------------------------------------------------------------------------------
// interface Statistic      ----------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------

package mosaic.sim.kernel.statistics;

/**
* Interface for all statistics beans.
* Defines method to receive a new observation, make a report, get the min, max, mean and standard deviation.
*/

public interface Statistic  {

// reporting the statistics data

  /** Accept new value for the statistic */
  public void newObservation (Object newVal);

  /** Reports the statistics data to an output file */
  public void report (java.io.DataOutputStream out) throws java.io.IOException;

  /** Gets the minimum value */
  public double getMin ();

  /** Gets the maximum value */
  public double getMax ();

  /** Gets the mean value */
  public double getMean ();

  /** Gets the standard deviation value */
  public double getStandardDeviation ();

}
