/**
 * Project mosaic
 *
 * VariableException.java
 *
 * copyright 2000, JKU Linz, Austria
 *
 */

package mosaic.sim.kernel.variable;

import mosaic.sim.kernel.SimException;

/**
* Exception class for all exceptions which occur when handling variables.
*/

public class VariableException extends SimException {

    /**
     * Contructor which takes the variable when the exception occurred.
     * @param _var the variable
     */
    public VariableException(mosaic.sim.kernel.variable.Variable _var) {
        this("variable exception", _var);
    }

    /**
     * Contructor which takes the variable when the exception occurred.
     * @param _var the variable
     * @param s Exception message 
     */
    public VariableException(String message, mosaic.sim.kernel.variable.Variable _var) {
        super(message);
        variable = _var;
    }

// variable ----------------------------------------------------------------------------------------

   /** the variable for this exception */
    protected mosaic.sim.kernel.variable.Variable variable;

   /**
    * Gets the variable for this exception
    * @return The variable
    */
   public mosaic.sim.kernel.variable.Variable getVariable() {
      return variable;
   }

} // end VariableAllreadyDefinedExpection ----------------------------------------------------------


