/* Generated by Together */

package mosaic.sim.util.simplevect2d;

/** Implements a 2d vector with an x and an y component. Most of the methods work directly on
 *  the object and return this. This supports the writing of expression. If the original value
 *  should not be altered, then the methods ending on C (e.g. addC()) should be used, as
 *  they will copy the vector (the "C" for copy). If it doesn't matter  */
public class Vect2d {

// Attributes---------------------------------------------------------------------------------------

    /** The x component of the vector.*/
    private double x;

    /** The y component of the vector.*/
    private double y;

    /** Initializes the vector with (0,0) */
    public Vect2d() {
        x=0;
        y=0;
    }


// Constructors-------------------------------------------------------------------------------------

    /** Initializes the vector with (x,y). */
    public Vect2d(double x, double y){
        this.x=x;
        this.y=y;
    }

    /** Initializes the vector with (v,v). */
    public Vect2d(double v){
        this.x=v;
        this.y=v;
    }

    /** Initializes the vector with (v[0],v[1]). */
    public Vect2d(double[] v){
        x=v[0];
        y=v[1];
    }

    /** Initializes the vector with (((Double)v[0]).doubleValue(),((Double)v[1]).doubleValue()) */
    public Vect2d(Object[] v){
        x=((Double)v[0]).doubleValue();
        y=((Double)v[1]).doubleValue();
    }

// Properties---------------------------------------------------------------------------------------

    /** Returns the current x value. */
    public final double getX(){
            return x;
    }

    /** Sets the x value. */
    public final void setX(double x){
            this.x = x;
    }

    /** Returns the current y value. */
    public final double getY(){
            return y;
    }

    /** Set the current y value. */
    public final void setY(double y){
            this.y = y;
    }

    public final double[] getArray(){
        return new double[]{x,y};
    }

    public String toString(){
        return "("+x+","+y+")";
    }

// Working methods----------------------------------------------------------------------------------

    /** Returns a copy of this vector. */
    public final Vect2d copy() {
        return new Vect2d(x,y);
    }

    /** Returns a copy of this vector. */
    public final Object clone(){
        return new Vect2d(x,y);
    }

    /** Adds v to this vector and returns this vector. The vector will not be copied. */
    public final Vect2d add(Vect2d v){
        x=x+v.x;
        y=y+v.y;
        return this;
    }

    /** Adds v to this vector and returns this vector. The vector will not be copied. */
    public final Vect2d add(double v){
        x=x+v;
        y=y+v;
        return this;
    }

    /** The sum will be returned in a new Vect2d object. If it doesn't matter wheather the
     *  original object is altered than you should use add(v) as it is faster. */
    public final Vect2d addC(Vect2d v){
        Vect2d newV=copy();
        return newV.add(v);
    }

    /** The sum will be returned in a new Vect2d object. If it doesn't matter wheather the
     *  original object is altered than you should use add(v) as it is faster. */
    public final Vect2d addC(double v){
        Vect2d newV=copy();
        return newV.add(v);
    }

    /** Subtracts v from this vector and returns this vector. The vector will not be copied. */
    public final Vect2d sub(Vect2d v){
        x=x-v.x;
        y=y-v.y;
        return this;
    }

    /** Subtracts v from this vector and returns this vector. The vector will not be copied. */
    public final Vect2d sub(double v){
        x=x-v;
        y=y-v;
        return this;
    }

    /** The difference will be returned in a new Vect2d object. If it doesn't matter wheather the
     *  original object is altered than you should use sub(v) as it is faster. */
    public final Vect2d subC(Vect2d v){
        Vect2d newV=copy();
        return newV.sub(v);
    }

    /** The difference will be returned in a new Vect2d object. If it doesn't matter wheather the
     *  original object is altered than you should use sub(v) as it is faster. */
    public final Vect2d subC(double v){
        Vect2d newV=copy();
        return newV.sub(v);
    }

    /** Multiplies v with this vector (x*v.x,y*v.y) and returns this vector.
     *  The vector will not be copied. */
    public final Vect2d mul(Vect2d v){
        x=x*v.x;
        y=y*v.y;
        return this;
    }

    /** Multiplies v with this vector (x*v.x,y*v.y) and returns this vector.
     *  The vector will not be copied. */
    public final Vect2d mul(double v){
        x=x*v;
        y=y*v;
        return this;
    }

    /** The product will be returned in a new Vect2d object. If it doesn't matter wheather the
     *  original object is altered than you should use mul(v) as it is faster. */
    public final Vect2d mulC(Vect2d v){
        Vect2d newV=copy();
        return newV.mul(v);
    }

    /** The product will be returned in a new Vect2d object. If it doesn't matter wheather the
     *  original object is altered than you should use mul(v) as it is faster. */
    public final Vect2d mulC(double v){
        Vect2d newV=copy();
        return newV.mul(v);
    }

    /** Divides this vector by v (x/v.x,y/v.y) and returns this vector.
     *  The vector will not be copied. */
    public final Vect2d div(Vect2d v){
        x=x/v.x;
        y=y/v.y;
        return this;
    }

    /** Divides this vector by v (x/v,y/v) and returns this vector.
     *  The vector will not be copied. */
    public final Vect2d div(double v){
        x=x/v;
        y=y/v;
        return this;
    }

    /** Calculates the vector product. */
    public final double dot(Vect2d v){
        return x*v.x+y*v.y;
    }

    /** The quotient will be returned in a new Vect2d object. If it doesn't matter wheather the
     *  original object is altered than you should use div(v) as it is faster. */
    public final Vect2d divC(Vect2d v){
        Vect2d newV=copy();
        return newV.div(v);
    }

    /** The quotient will be returned in a new Vect2d object. If it doesn't matter wheather the
     *  original object is altered than you should use div(v) as it is faster. */
    public final Vect2d divC(double v){
        Vect2d newV=copy();
        return newV.div(v);
    }

    /** Returns the length of the vector. */
    public final double length(){
        return Math.sqrt(x*x+y*y);
    }

    /** Returns the angle in degrees. */
    public final double phi(){
        if (x==0&&y==0) return 0;
        if (x==0) if (y<0) return 270; else return 90;
        if (y==0) if (x<0) return 180; else return 0;
        return  Math.toDegrees(Math.atan(y/x));
    }

    /** Calculates the normed vector (length will be 1) and returns this. */
    public final Vect2d normed(){
        return div(length());
    }

    /** Same as normed(), but the object won't be alterd and a copy returned instead. */
    public final Vect2d normedC(){
        Vect2d newV=copy();
        return newV.normed();
    }

    /** Calcualtes the normal vector and returns this. */
    public final Vect2d normal(){
        double dummy=x;
        x=-y;
        y=dummy;
        return this;
    }

    /** Same as normal(), but the calculation will be performed on a copy. */
    public final Vect2d normalC(){
        Vect2d newV=copy();
        return newV.normal();
    }

    /** Rotates the vector by the given degree. */
    public final Vect2d rotate(double phi){
        double newX,newY;
        double phiRad=Math.toRadians(phi);
        double cosPhi=Math.cos(phi);
        double sinPhi=Math.sin(phi);
        newX=x*cosPhi-y*sinPhi;
        newY=x*sinPhi+y*cosPhi;
        x=newX;
        y=newY;
        return this;
    }

    /** Rotates a copy. */
    public final Vect2d rotateC(double phi){
        Vect2d newV=copy();
        return newV.rotate(phi);
    }


}
