package mosaic.util.custom;

import java.beans.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

/**
 * Editor, with JFileChooser as a CustomEditor for choosing a file.
 *
 * @version 26 Mar 1999
 * @author Thomas Hilpold
 */
public class FilePathEditor extends PropertyEditorSupport {

    public String getAsText () {
        return (String)getValue();
     }

    public Object getValue() {
        if (super.getValue() == null) setValue("");
        return super.getValue();
    }

    public void setAsText(String text)
            throws java.lang.IllegalArgumentException {
        if (text != null) setValue (text);
        else throw (new IllegalArgumentException());
    }

    public String[] getTags () {
        return null;
    }

   /** duplicate '\' for proper code String */
    public String getJavaInitializationString() {
        StringBuffer retBuf;
        int numOfInserts;
        retBuf = new StringBuffer(getAsText());
        numOfInserts = 0;
        for (int pos = 0; pos < retBuf.length(); pos++)
            if (retBuf.charAt(pos) == '\\')
                retBuf.insert( ++pos, '\\');
        return "\"" + retBuf.toString() + "\"";
    }

    public boolean supportsCustomEditor() {
        return true;
    }

    public java.awt.Component getCustomEditor() {
        return new FilePathCustomEditor(this);
    }
}
