package mosaic.util.custom;

import java.awt.*;
import javax.swing.*;

/**
 *  Runtime version of the Propertysheet, which was initially thought to
 *  work at design time.
 *  This version changes the initally given object; (no copying)
 */
public class RTPropertySheet extends PropertySheet {

    public RTPropertySheet(Object bean) {
        super(bean, null);
    }
    /**
     */
    public void beanChanged(Object newBean) {
        bean = newBean;
        initialize();
        analyzeBean();
        // Scrollablepanels xsize will depend on viewport
        JPanel p = new ScrollablePanel();
        GridBagConstraints propPanelConstr = new GridBagConstraints();
        propPanelConstr.weightx = 1;
        propPanelConstr.weighty = 1;
        propPanelConstr.fill = GridBagConstraints.HORIZONTAL;
        propPanelConstr.anchor = GridBagConstraints.NORTHWEST;
        p.setLayout(new GridBagLayout());
        // add propPanel with topleft alignment, even if viewport > propPanel
        p.add(propPanel, propPanelConstr);
        scrollPane = new JScrollPane();
        scrollPane.setHorizontalScrollBarPolicy(
            JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        scrollPane.setVerticalScrollBarPolicy(
            JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        scrollPane.getViewport().setBackingStoreEnabled(true);
        //scrollPane.getViewport().setPreferredSize(propPanel.getPreferredSize());
        scrollPane.getViewport().setView(p);
    }
}
