package mosaic.util.custom;

import java.awt.*;
import javax.swing.*;

/**
 * Panel that implements the Scrollable Interface to track the width of
 * the viewport, when embedded in a Scrollpane. So a horizontal scrollbar
 * will never appear.
 *
 * Used by PropertySheet
 *
 *  @author Thomas Hilpold
 *  @version 01 Mar 1999
 *  @see PropertyCustomEditor
 *  @see GenericBeanEditor
 */
class ScrollablePanel extends JPanel implements Scrollable {

    //
    // Implementing Interface Scrollable
    //
    public Dimension getPreferredScrollableViewportSize() {
        return getPreferredSize();
    }

    public int getScrollableUnitIncrement(Rectangle visibleRect, int orientation, int direction) {
        return 20;
    }

    public int getScrollableBlockIncrement(Rectangle visibleRect, int orientation, int direction) {
        return 20;
    }

    public boolean getScrollableTracksViewportWidth() {
        return true;
    }

    public boolean getScrollableTracksViewportHeight() {
        return false;
    }
}
