
//Title:        Ihr Produktname
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       H. Praehofer
//Company:      Johannes Kepler University Linz
//Description:  Ihre Beschreibung

package mosaic.vis.input;

import java.beans.*;

public class SwitchBeanInfo extends SimpleBeanInfo {
  Class beanClass = Switch.class;
  String iconColor16x16Filename;
  String iconColor32x32Filename = "BooleanInputViewC32.gif";
  String iconMono16x16Filename;
  String iconMono32x32Filename;

  public SwitchBeanInfo() {
  }

  public PropertyDescriptor[] getPropertyDescriptors() {
    try  {
      PropertyDescriptor _highlightColor = new PropertyDescriptor("highlightColor", beanClass, "getHighlightColor", "setHighlightColor");
      PropertyDescriptor _offLabel = new PropertyDescriptor("offLabel", beanClass, "getOffLabel", "setOffLabel");
      PropertyDescriptor _onLabel = new PropertyDescriptor("onLabel", beanClass, "getOnLabel", "setOnLabel");
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
	      _highlightColor,
	      _offLabel,
	      _onLabel,};
      return pds;



    }
    catch(IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }

  public java.awt.Image getIcon(int iconKind) {
    switch (iconKind) {
	    case BeanInfo.ICON_COLOR_16x16:
	      return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
	    case BeanInfo.ICON_COLOR_32x32:
	      return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
	    case BeanInfo.ICON_MONO_16x16:
	      return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
	    case BeanInfo.ICON_MONO_32x32:
	      return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
	  }
    return null;
  }

  public BeanInfo[] getAdditionalBeanInfo() {
    Class superclass = beanClass.getSuperclass();
    try  {
      BeanInfo superBeanInfo = Introspector.getBeanInfo(superclass);
      return new BeanInfo[] { superBeanInfo };
    }
    catch(IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }
} 