package mosaic.vis.output;

import java.awt.*;
import javax.swing.*;
import mosaic.sim.kernel.variable.*;
import mosaic.sim.kernel.*;

public class BoolWheelView extends WheelView implements VariableChangeListener {

    //
    // Construction
    //

    public BoolWheelView() {
        this(3, 4, POINT_MODE, 15);
    }

    public BoolWheelView(int nrOfSpokes) {
        this(nrOfSpokes, 4, POINT_MODE, 15);
    }

    public BoolWheelView(int nrOfSpokes, int spokeWidth, int mode, double angleIncrement) {
        super(nrOfSpokes, spokeWidth, mode);
        setAngleIncrement(angleIncrement);
    }

    //
    // Property
    //

    //curAngleIncrement defined in superclass

    public void setAngleIncrement(double a) {
        curAngleIncrement = a;
    }

    public double getAngleIncrement() {
        return curAngleIncrement;
    }

    //
    // Listening to a boolean variable
    //

    public void variableChange (VariableChangeEvent e) {
        super.variableChange(e);
        if (e.getValue() instanceof Boolean) {
            isOn = ((Boolean)e.getValue()).booleanValue();
        } else {
            System.err.println("Error in BoolWheelView: variableChange val: " + e.getValue());
        }
        repaint();
    }

    public void propertyChange (java.beans.PropertyChangeEvent e){};
    public void addListenerVariable (Variable v){
        getSimApplication().getAnimator().addView(this);
    };
    public void removeListenerVariable (Variable v){
        getSimApplication().getAnimator().removeView(this);
    };

}
